function Create(self)

	self.gatherRange = 75;
	self.gatherPull = 3;
	self.collectRange = self.Radius * 0.5;
	self.digStrength = 30;
	
	self.resource = 0;

	self.gravityPerFrame = SceneMan.Scene.GlobalAcc * GetMPP() * rte.PxTravelledPerFrame;
end
function Update(self)
	self.controller = self:GetController();
	if self.controller:IsState(Controller.AIM_SHARP) then
		local randAngle = math.pi * math.random();
		local particleCount = self.IndividualRadius;
	
		local skipPx = 3;
		local rays = {{trace = Vector(0, self.Radius), pos = Vector(self.Pos.X + math.random(-self.gatherRange, self.gatherRange), self.Pos.Y)}, {trace = Vector(0, self.Radius):RadRotate(math.pi * RangeRand(-0.5, 0.5)), pos = self.Pos}};
		for _, ray in pairs(rays) do
			local hitPos = Vector(ray.pos.X, ray.pos.Y);
			if SceneMan:GetTerrMatter(ray.pos.X, ray.pos.Y) == rte.airID and SceneMan:CastStrengthRay(ray.pos, ray.trace, self.digStrength, hitPos, skipPx, rte.airID, false) then
				local dig = CreateMOPixel("Sandwitch Digger Particle");
				dig.Pos = hitPos - ray.trace:SetMagnitude(skipPx);
				dig.Vel = ray.trace:SetMagnitude(skipPx/rte.PxTravelledPerFrame);
				dig.Sharpness = self.digStrength/(dig.Vel.Magnitude * dig.Mass);
				MovableMan:AddParticle(dig);
			end
		end
		for particle in MovableMan.Particles do
			if string.find(particle.Material.PresetName, "Sand") then
				local dist = SceneMan:ShortestDistance(self.Pos, particle.Pos, SceneMan.SceneWrapsX);
				if dist.Magnitude < self.collectRange then
					self.resource = self.resource + 1;
					particle.ToDelete = true;
					local smoke = CreateMOSParticle("Tiny Smoke Ball 1");
					smoke.Pos = particle.Pos - dist * math.random();
					MovableMan:AddParticle(smoke);
				elseif dist.Magnitude < self.gatherRange then
					local distScalar = dist.Magnitude/self.gatherRange;
					dist:SetMagnitude(self.gatherPull);
					particle.Vel = (particle.Vel - dist) * distScalar - self.gravityPerFrame;
					particle.Pos = particle.Pos - dist * (1 - distScalar);
				end
			end
		end
	end
	if self.resource > 0 then
		--PrimitiveMan:DrawTextPrimitive(self.Pos, "" .. self.resource, true, 1);
	end
end