function Create(self)
	self.containerType = self:StringValueExists("ContainerType") and self:GetStringValue("ContainerType") or "Default";
	self.healthBoost = self:GetNumberValue("HealthBoost");
	self.alcoholLevel = math.min(self:GetNumberValue("AlcoholPercentage"), 100);
	
	self.full = true;
	self.lastVel = Vector(self.Vel.X, self.Vel.Y);
	self.spillness = 0.4;
end
function Update(self)

	self.Frame = self.full and 0 or 1;
	-- don't spill!!
	if self.full then
		if self.ToDelete then
			for i = 1, 10 do
				local drop = CreateMOPixel(self.PresetName .." Spill");
				drop.Pos = Vector(self.MuzzlePos.X, self.MuzzlePos.Y);
				drop.Vel = Vector(self.Vel.X, self.Vel.Y) + Vector(math.random() * self.Vel.Magnitude, 0):RadRotate(6.28 * math.random());
				MovableMan:AddParticle(drop);
			end
			local spray = CreateMOSParticle(self.PresetName .." Spill");
			spray.Pos = Vector(self.MuzzlePos.X, self.MuzzlePos.Y);
			spray.Vel = Vector(self.Vel.X, self.Vel.Y);
			MovableMan:AddParticle(spray);
			
			self.full = false;
		elseif self.containerType ~= "Bottle" then
			local vel = self.Vel - self.lastVel;
			local unSpillness = 1 - self.spillness;
			if (math.abs(self.RotAngle) > unSpillness * math.pi or vel.Magnitude + math.abs(self.AngularVel) > unSpillness * 10) then
				for i = 1, 10 do
					local drop = CreateMOPixel(self.PresetName .." Spill");
					drop.Pos = self.MuzzlePos;
					drop.Vel = self.Vel + vel + Vector(math.random() * self.Vel.Magnitude, 0):RadRotate(6.28 * math.random());
					MovableMan:AddParticle(drop);
				end
				local spray = CreateMOSParticle(self.PresetName .." Spill");
				spray.Pos = self.MuzzlePos;
				spray.Vel = self.Vel + vel;
				MovableMan:AddParticle(spray);
				
				self.full = false;
			end
		end
	end

	local actor = self:GetRootParent();
	if actor and IsAHuman(actor) then
		actor = ToAHuman(actor);
		if self:IsActivated() then
			self.StanceOffset = Vector(2, -1);
			self.RotAngle = (self.RotAngle + (self.StanceOffset * self.FlipFactor).AbsRadAngle * 2);
		else
			self.RotAngle = self.RotAngle * 0.5;
			self.StanceOffset = Vector(7, 5);
		end
		if self.FiredFrame then
			
			if self.full then
				--actor.SharpAimDelay = actor.SharpAimDelay / strength;
				
				if not actor:NumberValueExists("AlcoholLevel") then	-- Effect particle doesn't exist yet
					local effect = CreateMOSRotating("FoodFight.rte/Alcohol Effect");
					effect.Pos = actor.Pos;
					effect.Sharpness = actor.ID;
					MovableMan:AddMO(effect);
				end

				actor:SetNumberValue("AlcoholLevel", actor:GetNumberValue("AlcoholLevel") + self.alcoholLevel/(1 + math.sqrt(1 + math.abs(actor.Mass))));

				actor.Health = math.min(actor.Health * (1 + self.healthBoost) + self.healthBoost, actor.MaxHealth);
				
				self.full = false;
			--[[else
				local gib = CreateMOSRotating(self:GetModuleAndPresetName().. " Empty");
				gib.Pos = self.Pos;
				gib.HFlipped = self.HFlipped;
				gib.AngularVel = self.AngularVel;
				gib.RotAngle = self.RotAngle;
				gib.Team = self.Team;
				gib.IgnoresTeamHits = true;
				
				gib.Vel = self.Vel + Vector(5 * actor.FlipFactor, -1):RadRotate(actor:GetAimAngle(false));
			
				MovableMan:AddParticle(gib);

				self.ToDelete = true;]]--
			end
		end
	end
	if self.Magazine then
		self.RateOfFire = self.full and 1000 or 0;
		self.Magazine.RoundCount = self.full and 1 or 0;
	end
	self.lastVel = Vector(self.Vel.X, self.Vel.Y);
end