function Create(self)
	self.soberingRate = 0.003;
	self.checkTimer = Timer();
	
	if self.Sharpness ~= rte.NoMOID then
		self.target = MovableMan:GetMOFromID(self.Sharpness);
		if IsAHuman(self.target) then
			self.target = ToAHuman(self.target);
			self.targetOrigSpeed = self.target:GetLimbPathSpeed(1);
			self.parts = {self.target.Head, self.target.FGArm, self.target.BGArm, self.target.FGLeg, self.target.BGLeg};
		else
			self.ToDelete = true;
		end
	end
	self.rotAngle = 0;
	
	self.nausea = 0;
end
function Update(self)
	self.ToSettle = false;
	if self.target and IsAHuman(self.target) and self.target.Status < Actor.DYING then
		local targetAlcLevel = self.target:GetNumberValue("AlcoholLevel");
		if targetAlcLevel > 0 then
			local controller = self.target:GetController();
			local dizzy = math.sin(self.rotAngle) * (targetAlcLevel * 0.04);
			if self.target.Status == Actor.INACTIVE then	-- Passed out
				for i = 0, 40 do	-- Go through and disable all 40 + 1 controller states
					controller:SetState(i, false);
				end
				if targetAlcLevel > 3 and self.target.Head then
					local dots = targetAlcLevel;
					for i = 1, dots do
						local part = CreateMOPixel("Puke " ..math.random(3));
						part.Pos = self.target.Head.Pos + Vector(math.random(), math.random());
						part.Vel = Vector(math.random() * self.target.Head.Radius * self.target.Head.FlipFactor, 0):RadRotate(self.target.Head.RotAngle + RangeRand(-0.2, 0.2));
						MovableMan:AddParticle(part);
						targetAlcLevel = targetAlcLevel/(1 + self.soberingRate) - self.soberingRate;
					end
				end
				self.target:SetNumberValue("AlcoholLevel", targetAlcLevel - self.soberingRate);
			else
				local targetAlcFactor = (1 + targetAlcLevel * 0.5);
				if self.checkTimer:IsPastSimMS(1000/targetAlcFactor) then
					self.checkTimer:Reset();

					--controller:SetState(math.random(0, 40), false);
					local goof = {Controller.AIM_UP, Controller.AIM_DOWN};
					controller:SetState(goof[math.random(#goof)], (math.random() < 0.5));
						
					self.target:SetLimbPathSpeed(1, self.targetOrigSpeed * (RangeRand(1/targetAlcFactor, targetAlcFactor)/targetAlcFactor));
					--self.target.LimbPathPushForce = self.target.LimbPathPushForce + (2000 * self.speedBoost / (1 + self.target.LimbPathPushForce / 4000));
		
					if self.target.Status < Actor.INACTIVE then
						local velFactor = 1 + ((self.target.Vel + self.target.PrevVel).Magnitude * 0.01 + math.abs(self.target.AngularVel - self.target.RotAngle));
						local motion = math.random() * targetAlcLevel * velFactor + math.random() * (self.target.TravelImpulse.Magnitude/math.max(self.target.Mass, 1));
						if motion > 10 then
							self.target.Status = Actor.UNSTABLE;
							self.target.AngularVel = self.target.AngularVel + ((math.sqrt(targetAlcFactor) - (1 + self.Vel.X)) * RangeRand(-3, 3)/velFactor);
						else
							self.target.AngularVel = self.target.AngularVel + ((math.sqrt(targetAlcFactor) - (1 + self.Vel.X)) * RangeRand(-6, 6)/velFactor);
						end
						if motion > (3 + self.target.Health * 0.05) then
							self.target.Status = Actor.INACTIVE;
							self.target.Health = (self.target.Health + self.target.MaxHealth) * 0.5;
							self.target.ToSettle = true;
							self.target.HUDVisible = false;
							self.target.DeathSound = nil;
				
							self.target:DropAllInventory();
							controller:SetState(Controller.WEAPON_DROP, true);
						end
					end
					if (math.random() * targetAlcLevel) > 7 then
						self.target.Health = self.target.Health - 1;
					end
					if self.target:NumberValueExists("OrigImpulseDamageThreshold") then
						self.target.ImpulseDamageThreshold = self.target:GetNumberValue("OrigImpulseDamageThreshold") * targetAlcFactor;
					else
						self.target:SetNumberValue("OrigImpulseDamageThreshold", self.target.ImpulseDamageThreshold);
					end
					for _, limb in pairs(self.parts) do
						if limb then
							if limb:NumberValueExists("OrigDamageMultiplier") then
								limb.DamageMultiplier = limb:GetNumberValue("OrigDamageMultiplier")/targetAlcFactor;
							else
								limb:SetNumberValue("OrigDamageMultiplier", limb.DamageMultiplier);
							end
						end
					end
					self.target:SetNumberValue("AlcoholLevel", targetAlcLevel - self.soberingRate);
				end
				self.rotAngle = self.rotAngle + (RangeRand(-1, 1)/targetAlcFactor);
				self.nausea = self.nausea + targetAlcLevel;
				self.target.ViewPoint = self.target.ViewPoint + Vector(targetAlcLevel * 5 + dizzy * 50 * math.sin(self.nausea * 0.01), 0):DegRotate(self.nausea);
				if self.target.EquippedItem and IsAttachable(self.target.EquippedItem) then
					local item = ToAttachable(self.target.EquippedItem);
					local setAngle = dizzy * item.FlipFactor/(2 + math.abs(item.RotAngle));
					item.RotAngle = item.RotAngle + setAngle;
					local jointOffset = Vector(item.JointOffset.X * item.FlipFactor, item.JointOffset.Y):RadRotate(item.RotAngle);
					item.Pos = item.Pos - jointOffset + Vector(jointOffset.X, jointOffset.Y):RadRotate(-setAngle);
				end
			end
			if self.target.Head then
				local setAngle = dizzy * self.target.Head.FlipFactor/(2 + math.abs(self.target.Head.RotAngle));
				self.target.Head.RotAngle = self.target.Head.RotAngle + setAngle;
				local jointOffset = Vector(self.target.Head.JointOffset.X * self.target.Head.FlipFactor, self.target.Head.JointOffset.Y):RadRotate(self.target.Head.RotAngle);
				self.target.Head.Pos = self.target.Head.Pos - jointOffset + Vector(jointOffset.X, jointOffset.Y):RadRotate(-setAngle);
			end
		else
			if self.target.Status == Actor.INACTIVE then
				self.target.Status = Actor.UNSTABLE;
				self.target.HUDVisible = true;
			end
			self.ToDelete = true;
		end
	else
		self.target = nil;
		self.ToDelete = true;
	end
end
function Destroy(self)
	if self.target and IsAHuman(self.target) then
		self.target:SetLimbPathSpeed(1, self.targetOrigSpeed);
		self.target:RemoveNumberValue("AlcoholLevel");

		for _, limb in pairs(self.parts) do
			if limb and limb:NumberValueExists("OrigDamageMultiplier") then
				limb.DamageMultiplier = limb:GetNumberValue("OrigDamageMultiplier");
			end
		end	
	end
end