function Create(self)
	self.speedBoost = self:GetNumberValue("SpeedBoost");
	self.healthBoost = self:GetNumberValue("HealthBoost");
	self.temperature = self:GetNumberValue("Temperature");
	
	self.full = true;
	self.lastVel = Vector(self.Vel.X, self.Vel.Y);
	
	if self.temperature > 60 then
		self.steaming = Timer();
	end
	self.spillness = 0.5;
end
function Update(self)
	self.Frame = self.full and 0 or 1;
	-- don't spill!!
	if self.full then
		if self.ToDelete then
			for i = 1, 5 do
				local drop = CreateMOPixel(self.PresetName .." Spill");
				drop.Pos = Vector(self.MuzzlePos.X, self.MuzzlePos.Y);
				drop.Vel = self.Vel + Vector(math.random() * self.Vel.Magnitude, 0):RadRotate(math.pi * 2 * math.random());
				MovableMan:AddParticle(drop);
			end
			local spray = CreateMOSParticle(self.PresetName .." Spill");
			spray.Pos = Vector(self.MuzzlePos.X, self.MuzzlePos.Y);
			spray.Vel = self.Vel;
			MovableMan:AddParticle(spray);
			
			self.full = false;
		else
			if self.steaming then
				-- drink it while it's hot!
				if self.temperature < 30 then
					self.steaming = nil;
					self.speedBoost = self.speedBoost * 0.75;
					self.healthBoost = self.healthBoost * 0.75;
				else
					if self.steaming:IsPastSimMS(30000/self.temperature) then
						self.steaming:Reset();
						self.temperature = self.temperature - 0.1;
						
						local smoke = CreateMOSParticle("Tiny Smoke Ball 1");
						smoke.Pos = self.MuzzlePos;
						smoke.HitsMOs = false;
						smoke.Vel = self.Vel * 0.5 - Vector(0, math.random());
						smoke.Lifetime = math.random(200);
						smoke.GlobalAccScalar = RangeRand(-1, -0.1);
						MovableMan:AddParticle(smoke);
					end
				end
			end
			local vel = self.Vel - self.lastVel;
			local unSpillness = 1 - self.spillness;
			if (math.abs(self.RotAngle) > unSpillness * math.pi or vel.Magnitude + math.abs(self.AngularVel) > unSpillness * 10) then
				for i = 1, 5 do
					local drop = CreateMOPixel(self.PresetName .." Spill");
					drop.Pos = self.MuzzlePos;
					drop.Vel = self.Vel + vel + Vector(math.random() * self.Vel.Magnitude, 0):RadRotate(math.pi * 2 * math.random());
					MovableMan:AddParticle(drop);
				end
				local spray = CreateMOSParticle(self.PresetName .." Spill");
				spray.Pos = self.MuzzlePos;
				spray.Vel = self.Vel + vel;
				MovableMan:AddParticle(spray);
				
				self.full = false;
			end
		end
	end
	local actor = self:GetRootParent();
	if actor and (IsAHuman(actor) or IsACrab(actor)) then
		actor = IsAHuman(actor) and ToAHuman(actor) or ToACrab(actor);
		if self:IsActivated() then
			self.StanceOffset = Vector(2, -1);
			self.RotAngle = (self.RotAngle + (self.StanceOffset * self.FlipFactor).AbsRadAngle);
		else
			self.RotAngle = self.RotAngle * 0.5;
			self.StanceOffset = Vector(7, 5);
		end
		if self.FiredFrame then
			
			if self.full then
				
				actor:SetLimbPathSpeed(0, actor:GetLimbPathSpeed(0) + (self.speedBoost/(1 + actor:GetLimbPathSpeed(0) * 0.1))	);
				actor:SetLimbPathSpeed(1, actor:GetLimbPathSpeed(1) + (self.speedBoost/(1 + actor:GetLimbPathSpeed(1) * 0.1))	);
				actor:SetLimbPathSpeed(2, actor:GetLimbPathSpeed(2) + (self.speedBoost/(1 + actor:GetLimbPathSpeed(2) * 0.1))	);
				actor.LimbPathPushForce = actor.LimbPathPushForce + (2000 * self.speedBoost/(1 + actor.LimbPathPushForce/4000));
				
				actor.ThrowPrepTime = actor.ThrowPrepTime/(1 + self.speedBoost);
				--actor.SharpAimDelay = actor.SharpAimDelay/(1 + self.speedBoost);
				
				actor.Health = math.min(actor.Health * (1 + self.healthBoost), actor.MaxHealth);
				
				self.full = false;
			else
				local gib = CreateMOSRotating(self:GetModuleAndPresetName().. " Empty");
				gib.Pos = self.Pos;
				gib.HFlipped = self.HFlipped;
				gib.AngularVel = self.AngularVel;
				gib.RotAngle = self.RotAngle;
				gib.Team = self.Team;
				gib.IgnoresTeamHits = true;
				
				gib.Vel = self.Vel + Vector(5 * actor.FlipFactor, -1):RadRotate(actor:GetAimAngle(false));
			
				MovableMan:AddParticle(gib);

				self.ToDelete = true;
			end
		end
	end
	if self.Magazine then
		self.RateOfFire = self.full and 1000 or 0;
		self.Magazine.RoundCount = self.full and 1 or 0;
	end
	self.lastVel = Vector(self.Vel.X, self.Vel.Y);
end