function Create(self)
	self.Frame = math.random(self.FrameCount) - 1;
	-- sharpness: tablespoon < butterknife < fork
	self.Sharpness = self.Sharpness * (1 + self.Frame/self.FrameCount);
	self.lastVel = Vector(self.Vel.X, self.Vel.Y);
	
	self.soundRiccochetCount = 0;
	self.soundRiccochet = CreateSoundContainer("Utensil Riccochet", "FoodFight.rte");
	self.soundImpact = CreateSoundContainer("Utensil Impact", "FoodFight.rte");
	
	self.lifeTimer = Timer();
	self.gibTime = 5000;
end

function Update(self)
	if self.target and self.PinStrength > 0 then
		if IsMOSRotating(self.target) and not self.target.ToDelete then
			self.Vel = Vector();
			self.AngularVel = 0;

			self.Pos = self.target.Pos - Vector(self.stickPos.X, self.stickPos.Y):RadRotate(self.target.RotAngle - self.targetStickAngle);
			self.RotAngle = self.stickAngle + (self.target.RotAngle - self.targetStickAngle);
		else
			self.Vel = self.Vel + Vector(math.random(), 0):RadRotate(6.28 * math.random());
			self.AngularVel = self.AngularVel + math.random(-5, 5);
			self.PinStrength = 0;
		end
	else
		self.target = nil;
		self.AngularVel = self.AngularVel * 0.99;
			
		if self.lastVel.Magnitude > 10 then
			local riccochet = true;
			
			local dots = self.Vel.Magnitude * rte.PxTravelledPerFrame
			local trace = Vector(dots * self.FlipFactor, 0):RadRotate(self.RotAngle);
			local hitPos = Vector(self.Pos.X, self.Pos.Y);
			local obstRay = SceneMan:CastObstacleRay(self.Pos, trace, hitPos, Vector(), self.ID, self.Team, 0, (dots * 0.33));
			if obstRay >= 0 then
				local penetration = self.Vel.Magnitude * self.Mass * self.Sharpness;
				local moCheck = SceneMan:GetMOIDPixel(hitPos.X, hitPos.Y);
				if moCheck == rte.NoMOID then	-- hit terrain
					local matStrength = SceneMan:GetMaterialFromID(SceneMan:GetTerrMatter(hitPos.X, hitPos.Y)).StructuralIntegrity;
					if matStrength > (penetration * 0.5) then
						if matStrength < penetration then	-- stick to terrain
							self.Vel = Vector();
							self.Pos = self.Pos + Vector(trace.X, trace.Y):SetMagnitude(obstRay - self.Radius);
							self.PinStrength = matStrength;
							self.ToSettle = true;
							riccochet = false;	-- don't play riccochet sound when sticking
						end
					else
						riccochet = false;	-- don't play riccochet sound when sinking into weak terrain
					end
				else
					local mo = MovableMan:GetMOFromID(moCheck);
					if mo and penetration > mo.Material.StructuralIntegrity then
					
						self.target = ToMOSRotating(mo);
						self.PinStrength = self.target.Material.StructuralIntegrity;

						self.stickAngle = self.RotAngle;	-- own angle when sticking
						self.targetStickAngle = self.target.RotAngle;		-- target angle when sticking
						
						self.Pos = self.Pos + Vector(trace.X, trace.Y):SetMagnitude(obstRay - self.Radius);	-- close the distance
						self.stickPos = SceneMan:ShortestDistance(self.Pos, self.target.Pos, SceneMan.SceneWrapsX);
						-- add damage particle
						local part = CreateMOPixel("Food Fight Damage Particle");
						part.Pos = self.Pos;
						part.Vel = self.Vel;
						part.Mass = self.Mass;
						part.Sharpness = self.Sharpness;
						part.WoundDamageMultiplier = 2;
						MovableMan:AddParticle(part);
						
						riccochet = false;	-- don't play riccochet sound when sticking
						
						self.soundImpact.Volume = RangeRand(0.3, 0.7);
						self.soundImpact.Pitch = RangeRand(0.8, 1.2);
						self.soundImpact:Play(self.Pos);
					end
				end
			end
			
			if riccochet and self.soundRiccochetCount < 2 and math.random() < 0.5 then
				local ang = 0.1;	-- trajectory angle change to trigger riccochet sound, in rad
				if math.abs(self.lastVel.AbsRadAngle - self.Vel.AbsRadAngle) > ang and math.random() < (self.lastVel.Magnitude * 0.1) then
					--AudioMan:PlaySound("Base.rte/Sounds/Penetration/Riccochet".. math.random(5) ..".wav", self.Pos);
					self.soundRiccochet.Volume = RangeRand(0.1, 0.5);
					self.soundRiccochet.Pitch = RangeRand(0.9, 1.1) * 1.2;
					self.soundRiccochet:Play(self.Pos);
					
					self.soundRiccochetCount = self.soundRiccochetCount + 1;
				end
			end
			
			self.lifeTimer:Reset();
		elseif self.lifeTimer:IsPastSimMS(self.gibTime) then
			self:GibThis();
		end
	end
	self.lastVel = Vector(self.Vel.X, self.Vel.Y);
	if self.Age > (self.gibTime * 5) then
		self:GibThis();
	end
end