function Create(self)

	self.explodeTimer = Timer();
	self.partList = {};
	self.burnList = {};

	self.explodeTime = 2000;
	self.numOfParticles = 40;	-- orig = 50
	self.particlesPerOil = 2;	-- orig = 3

	self:EraseFromTerrain();
	self.Scale = 0;

	for i = 1, self.numOfParticles do
		self.partList[i] = CreateMOPixel("Browncoat Fuel Bomb Fuel");
		self.partList[i].Pos = self.Pos;
		self.partList[i].Vel = Vector((math.random()*20),0):RadRotate(6.28318*math.random()) + self.Vel;
		MovableMan:AddParticle(self.partList[i]);
		self.burnList[i] = Vector(self.Pos.X,self.Pos.Y);
		-- extra fx
		if i < self.numOfParticles/2 then
			local part = CreateMOSParticle("Oil Spray Particle");
			part.Pos = self.Pos;
			part.Lifetime = part.Lifetime*RangeRand(0.5,1.5);
			part.Vel = self.partList[i].Vel;
			MovableMan:AddParticle(part);
		end
	end
end

function Update(self)

	self.ToSettle = false;
	self.ToDelete = false;
	
	if self.explodeTimer:IsPastSimMS(self.explodeTime) then
		local soundCount = 0;
		for i = 1, #self.partList do
			if MovableMan:IsParticle(self.partList[i]) and self.partList[i].PresetName == "Browncoat Fuel Bomb Fuel" then

				if self.partList[i].target then
					local fire = CreateMOSParticle("Flame "..math.random(2).." Hurt");
					fire.Pos = self.partList[i].target.Pos + Vector(self.partList[i].sPosX,self.partList[i].sPosY);
					fire.Sharpness = self.partList[i].target.ID/1000;
					MovableMan:AddParticle(fire);
				end
				soundCount = soundCount + 1;
				if soundCount >= 10 then
					soundCount = 0;
					local sfx = CreateMOSRotating("Browncoat Fuel Bomb Burn Sound");
					sfx.Pos = Vector(self.partList[i].Pos.X,self.partList[i].Pos.Y);
					sfx:GibThis();
					MovableMan:AddParticle(sfx);
				end
				for j = 1, self.particlesPerOil do
					local firePar;
					local randNum = math.random();
					if randNum < 0.2 then
						firePar = CreateMOPixel("Particle Browncoat Incendiary Flame 1");
					elseif randNum < 0.4 then
						firePar = CreateMOPixel("Particle Browncoat Incendiary Flame 2");
					elseif randNum < 0.6 then
						firePar = CreateMOSParticle("Tiny Smoke Ball Incendiary Flamer 1");
					elseif randNum < 0.8 then
						firePar = CreateMOSParticle("Tiny Smoke Ball Incendiary Flamer 2");
					else
						firePar = CreateMOSParticle("Tiny Smoke Ball Incendiary Flamer 3");
					end
					local part = CreateMOSParticle("Flame Smoke 1");
					part.Pos = Vector(self.partList[i].Pos.X,self.partList[i].Pos.Y);
					part.Vel = Vector(math.random()*3,0):RadRotate(math.random()*6.28);
					part.Lifetime = 400*RangeRand(1.0,2.0);
					part.GlobalAccScalar = RangeRand(-0.5,0.0);
					MovableMan:AddParticle(part);
					
					firePar.Pos = Vector(self.partList[i].Pos.X,self.partList[i].Pos.Y);
					firePar.Vel = Vector((math.random()*5)+15,0):RadRotate(math.random()*6.28);
					MovableMan:AddParticle(firePar);
				end
				self.partList[i].ToDelete = true;
			end
		end
		self.ToDelete = true;
	else
	-- look for targets
		for i = 1, #self.partList do
			if MovableMan:IsParticle(self.partList[i]) and self.partList[i].PresetName == "Browncoat Fuel Bomb Fuel" then
		
				if self.partList[i].target and IsMOSRotating(self.partList[i].target)
				and self.partList[i].target.ID ~= 255 then

					if math.random() < 0.01 then	-- drip
						self.partList[i].Vel = self.partList[i].target.Vel;
						self.partList[i].Pos = self.partList[i].target.Pos - Vector(self.partList[i].sPosX,self.partList[i].sPosY):RadRotate(self.partList[i].target.RotAngle-self.partList[i].tsAngle);
					end
				else
					self.partList[i].target = nil;
					local velNum = math.floor(math.sqrt(self.partList[i].Vel.Magnitude+1));

					local mocheck = SceneMan:CastMORay(self.partList[i].Pos,Vector(velNum,0):RadRotate(self.partList[i].Vel.AbsRadAngle),self.partList[i].ID,-2,0,true,0);
					if mocheck ~= 255 then
						local mo = MovableMan:GetMOFromID(MovableMan:GetMOFromID(mocheck).ID);
						if mo and mo.PresetName ~= self.PresetName then

							self.partList[i].target = ToMOSRotating(mo);

							self.partList[i].tsAngle = mo.RotAngle;	-- target angle when sticking	

							self.partList[i].sPosX = (mo.Pos.X-self.partList[i].Pos.X) * 0.8;	-- for closing the distance a bit
							self.partList[i].sPosY = (mo.Pos.Y-self.partList[i].Pos.Y) * 0.8;

							self.partList[i].Pos = mo.Pos - Vector(self.partList[i].sPosX,self.partList[i].sPosY);
						end
					end
				end
			end
		end
	end
end